###########################################################
#                  Find VLFeat Library
#----------------------------------------------------------

find_path(VLFEAT_DIR sift.h mser.h
    HINTS "${VLFEAT_ROOT}" "$ENV{VLFEAT_ROOT}" "${VLFEAT_INCLUDE_DIR_HINTS}"
    PATHS "$ENV{PROGRAMFILES}/vl" "$ENV{PROGRAMW6432}/vl"
    PATH_SUFFIXES vl
    DOC "Root directory of VLFEAT includes")

##====================================================
## Include VLFEAT library
##----------------------------------------------------
if(EXISTS "${VLFEAT_DIR}" AND NOT "${VLFEAT_DIR}" STREQUAL "")
  set(VLFEAT_FOUND TRUE)
  set(VLFEAT_INCLUDE_DIRS ${VLFEAT_DIR})
  set(VLFEAT_DIR "${VLFEAT_DIR}" CACHE PATH "" FORCE)
  mark_as_advanced(VLFEAT_DIR)

  set(VLFEAT_INCLUDE_DIR ${VLFEAT_DIR})
  find_library(VLFEAT_LIBRARY NAMES vlfeat)

  # locate Flann libraries
  if(DEFINED VLFEAT_LIBRARY)
    set(VLFEAT_LIBRARIES ${VLFEAT_LIBRARY})
  endif()

  message(STATUS "VLFeat found (include: ${VLFEAT_INCLUDE_DIRS})")
else()
  message(FATAL_ERROR "You are attempting to build without VLFeat. "
          "Please use cmake variable -DVLFEAT_INCLUDE_DIR_HINTS:STRING=\"PATH\" "
          "or VLFEAT_INCLUDE_DIR_HINTS env. variable to a valid VLFeat path. ")
       package_report_not_found(VLFEAT "VLFeat cannot be found")
endif()
##====================================================
